// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (c) 2019 MediaTek Inc.
 */

#include <linux/backlight.h>
#include <drm/drm_mipi_dsi.h>
#include <drm/drm_panel.h>
#include <drm/drm_modes.h>
#include <linux/delay.h>
#include <drm/drm_connector.h>
#include <drm/drm_device.h>

#include <linux/gpio/consumer.h>
#include <linux/regulator/consumer.h>

#include <video/mipi_display.h>
#include <video/of_videomode.h>
#include <video/videomode.h>

#include <linux/module.h>
#include <linux/of_platform.h>
#include <linux/of_graph.h>
#include <linux/platform_device.h>

#define CONFIG_MTK_PANEL_EXT
#if defined(CONFIG_MTK_PANEL_EXT)
#include "../mediatek/mediatek_v2/mtk_panel_ext.h"
#include "../mediatek/mediatek_v2/mtk_drm_graphics_base.h"
#endif

#if IS_ENABLED(CONFIG_PRIZE_HARDWARE_INFO)
#include "../../../misc/mediatek/prize/hardware_info/hardware_info.h"
extern struct hardware_info current_lcm_info;
#endif

struct lcm {
	struct device *dev;
	struct drm_panel panel;
	struct backlight_device *backlight;
	struct gpio_desc *reset_gpio;
	struct gpio_desc *bias_pos;
	struct gpio_desc *bias_neg;
	struct gpio_desc *vldo18_gpio;
	bool prepared;
	bool enabled;

	int error;
};

unsigned int rawlevel;
struct lcm *g_ctx;

#define lcm_dcs_write_seq(ctx, seq...)                                         \
	({                                                                     \
		const u8 d[] = { seq };                                        \
		BUILD_BUG_ON_MSG(ARRAY_SIZE(d) > 256,                           \
				 "DCS sequence too big for stack");            \
		lcm_dcs_write(ctx, d, ARRAY_SIZE(d));                          \
	})

#define lcm_dcs_write_seq_static(ctx, seq...) \
({\
	static const u8 d[] = { seq };\
	lcm_dcs_write(ctx, d, ARRAY_SIZE(d));\
})

static inline struct lcm *panel_to_lcm(struct drm_panel *panel)
{
	return container_of(panel, struct lcm, panel);
}

#ifdef PANEL_SUPPORT_READBACK
static int lcm_dcs_read(struct lcm *ctx, u8 cmd, void *data, size_t len)
{
	struct mipi_dsi_device *dsi = to_mipi_dsi_device(ctx->dev);
	ssize_t ret;

	if (ctx->error < 0)
		return 0;

	ret = mipi_dsi_dcs_read(dsi, cmd, data, len);
	if (ret < 0) {
		dev_info(ctx->dev, "error %d reading dcs seq:(%#x)\n", ret,
			 cmd);
		ctx->error = ret;
	}

	return ret;
}

static void lcm_panel_get_data(struct lcm *ctx)
{
	u8 buffer[3] = { 0 };
	static int ret;

	pr_info("%s+\n", __func__);

	if (ret == 0) {
		ret = lcm_dcs_read(ctx, 0x0A, buffer, 1);
		pr_info("%s  0x%08x\n", __func__, buffer[0] | (buffer[1] << 8));
		dev_info(ctx->dev, "return %d data(0x%08x) to dsi engine\n",
			ret, buffer[0] | (buffer[1] << 8));
	}
}
#endif

static void lcm_dcs_write(struct lcm *ctx, const void *data, size_t len)
{
	struct mipi_dsi_device *dsi = to_mipi_dsi_device(ctx->dev);
	ssize_t ret;
	char *addr;

	if (ctx->error < 0)
		return;

	addr = (char *)data;
	if ((int)*addr < 0xB0)
		ret = mipi_dsi_dcs_write_buffer(dsi, data, len);
	else
		ret = mipi_dsi_generic_write(dsi, data, len);
	if (ret < 0) {
		dev_info(ctx->dev, "error %zd writing seq: %ph\n", ret, data);
		ctx->error = ret;
	}
}

static void lcm_panel_init(struct lcm *ctx)
{
dev_info(ctx->dev, "%s\n", __func__);
	
lcm_dcs_write_seq_static(ctx,0xF0,0x3C,0x3C);
lcm_dcs_write_seq_static(ctx,0xF1,0x3C,0x3C);

lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x00);
lcm_dcs_write_seq_static(ctx,0xD0,0x00,0x00,0x00,0x01);
lcm_dcs_write_seq_static(ctx,0xB4,0xB5,0x21,0x00);
lcm_dcs_write_seq_static(ctx,0xB5,0x00,0x40,0x0A,0x00,0x00,0xC0,0x0A,0x00);
lcm_dcs_write_seq_static(ctx,0xB7,0x21,0x76);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x01);
lcm_dcs_write_seq_static(ctx,0xB0,0x50,0x10,0x10,0x15,0x30);
lcm_dcs_write_seq_static(ctx,0xB1,0x47,0x60,0x09,0x38,0x04,0xD0,0x02,0x00,0x00,0x00,0x01,0x03,0x00,0x10,0x09,0x60,0x00,0x5A,0x00,0x5A,0x00,0x10,0x00,0x10,0x00,0x18,0x00,0x68,0x00,0x10,0x00,0x10,0x00,0x5A,0x00,0x5A,0x00,0x10,0x09,0x60,0x00,0x5A,0x00,0x5A,0x00,0x11,0x00,0x00,0x37,0x04,0x00,0x00,0x23,0x09,0x00,0x00,0xFF,0x00);
lcm_dcs_write_seq_static(ctx,0xB2,0x14,0x14,0x03,0x04,0x03,0x04,0x03,0x04,0x07,0x13,0x14,0x14,0x03,0x04,0x03,0x04,0x03,0x04,0x13,0x14,0x14,0x03);
lcm_dcs_write_seq_static(ctx,0xB3,0x40,0x01,0x38,0xA5,0xC9,0x00,0x30,0x01,0xC0,0xA6,0x41,0x00,0x01,0x00,0x00,0x00,0x00,0x11,0x53,0x44,0x02,0x77,0xB9,0xAA,0x68,0xFF);
lcm_dcs_write_seq_static(ctx,0xB3,0x40,0x01,0x38,0xA5,0xC9,0x00,0x30,0x01,0xC0,0xA6,0x41,0x00,0x01,0x00,0x00,0x00,0x00,0x11,0x20,0x44,0x35,0x77,0x86,0xAA,0x9B,0xFF);
lcm_dcs_write_seq_static(ctx,0xB4,0x32,0x22,0x26,0x56,0x12);
lcm_dcs_write_seq_static(ctx,0xB5,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0xF0,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB7,0x00,0xFB,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB8,0x09,0xAA,0x55,0xAA,0x55,0xAA,0x55,0xAA,0x55);
lcm_dcs_write_seq_static(ctx,0xBA,0x24,0x00,0x27,0x00,0x26,0x00,0x0C,0x00,0x0B,0x00,0x01,0x00,0x37,0x37,0x37,0x37,0x01,0x00,0x0C,0x00,0x0B,0x00,0x0C,0x00,0x0B,0x00,0x01,0x00,0x37,0x37,0x37,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBA,0x24,0x00,0x27,0x00,0x26,0x00,0x0C,0x00,0x0B,0x00,0x01,0x00,0x37,0x37,0x37,0x37,0x24,0x00,0x27,0x00,0x26,0x00,0x0C,0x00,0x0B,0x00,0x01,0x00,0x37,0x37,0x37,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBB,0x00,0x02,0x00,0x00,0x00,0x2B,0x00,0x00,0x00,0x00,0x79,0x79,0x00,0x00,0x79,0x79,0x00,0x00,0x79,0x79,0x00,0x00,0x79,0x79);
lcm_dcs_write_seq_static(ctx,0xBC,0x8B,0x01,0x00,0x0E,0x00,0x0B,0x00,0x0A,0x00,0x0C,0x00,0x0C,0x00,0x0E,0x01,0xAE,0x00,0x01,0xAE,0x00,0x01,0xAE,0x00,0x01,0xAE,0x00);
lcm_dcs_write_seq_static(ctx,0xBE,0x03,0x00,0x00,0x0E,0x04,0x00,0x12,0x12,0x00,0x12,0x12,0x00,0x12,0x12,0x00,0x12,0x12,0x00);
lcm_dcs_write_seq_static(ctx,0xC0,0x11,0x01,0x00,0x10,0x10,0x64,0x90,0x10,0x64,0x90,0x10,0x64,0x90,0x10,0x64,0x90,0xFF);
lcm_dcs_write_seq_static(ctx,0xC5,0x21,0x02,0x00,0x31,0x00,0x12,0xAA,0x00,0x12,0xAA,0x00,0x12,0xAA,0x00,0x12,0xAA,0xFF);
lcm_dcs_write_seq_static(ctx,0xC7,0x66,0x00,0x66,0x00,0x66,0x00,0x00,0x00,0x00,0x66,0x00,0x11,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xC8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x06,0x06,0x00,0x60,0x10,0x00,0x00,0x00,0x00,0x06,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF);
lcm_dcs_write_seq_static(ctx,0xC9,0x00,0x00,0x25,0x21,0x36,0x00,0x00,0x00,0x56,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x25,0x31,0x26,0x00,0x00,0x00,0x56,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x35,0x12,0x36,0x56,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x35,0x22,0x26,0x00,0x00,0x00,0x56,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x35,0x21,0x26,0x56,0x11);
lcm_dcs_write_seq_static(ctx,0xCE,0x01,0x30,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x00,0x00,0x02,0x02,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0xFF);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x02);
lcm_dcs_write_seq_static(ctx,0xB0,0x09,0x88,0x08,0x78,0x0A,0x54,0x1E,0x1E,0x19,0x1B,0x46,0x10,0x1E,0x00,0x38,0x77,0x6C,0x6C,0x33,0x33,0x33,0x33,0x73,0x33,0x33,0x33,0x32,0x04,0xB0,0x30);
lcm_dcs_write_seq_static(ctx,0xB0,0x09,0x88,0x08,0x62,0x00,0x54,0x1E,0x1E,0x19,0x1B,0x46,0x10,0x1E,0x00,0x38,0x77,0x6C,0x6C,0x33,0x33,0x33,0x33,0x73,0x33,0x33,0x33,0x32,0x04,0xB0,0x30);
lcm_dcs_write_seq_static(ctx,0xB0,0x09,0x88,0x08,0x62,0x00,0x54,0x1E,0x1E,0x19,0x1B,0x46,0x10,0x1E,0x00,0x38,0x77,0x6C,0x6C,0x33,0x33,0x33,0x33,0x73,0x33,0x33,0x33,0x32,0x04,0xF0,0x33);
lcm_dcs_write_seq_static(ctx,0xB1,0x19,0x88,0x08,0x6C,0x02,0x00,0x1E,0x1E,0x19,0x1B,0x46,0x10,0x1E,0x20,0x00,0x77,0x6C,0x6C,0x33,0x33,0x33,0x33,0x03,0x33,0x33,0x33,0x32,0x80);
lcm_dcs_write_seq_static(ctx,0xB2,0x00,0x00,0x77,0x19,0x21,0x29,0x01,0x03,0x05,0x07,0x07,0x08,0x09,0x0A,0x0D,0x0F,0x21,0x25,0x25,0x1C,0x00,0x77,0x19,0x21,0x29,0x01,0x03,0x05,0x07,0x08,0x09,0x0A,0x0B,0x0D,0x0F,0x25,0x21,0x21,0x00,0x00,0x00,0x00,0xFF);
lcm_dcs_write_seq_static(ctx,0xB3,0x00,0x00,0x00,0x00,0x01,0x01,0x02,0x03,0x03,0x07,0x04,0x04,0x05,0x06,0x07,0x07,0x08,0x08,0x09,0x09,0x09,0x09,0x09,0x8B,0x8C,0x09,0x0A,0x09,0x0B,0x0C,0x0C,0x0C,0x00,0x0E,0x18,0x1C,0x00,0x00,0x21,0x00);
lcm_dcs_write_seq_static(ctx,0xB3,0x00,0x00,0x00,0x00,0x01,0x01,0x02,0x03,0x03,0x07,0x04,0x04,0x05,0x06,0x07,0x07,0x08,0x08,0x09,0x09,0x09,0x09,0x09,0x8B,0x8C,0x09,0x0A,0x09,0x0B,0x0C,0x0C,0x0C,0x00,0x0E,0x14,0x18,0x00,0x00,0x21,0x00);
lcm_dcs_write_seq_static(ctx,0xB4,0xBB,0xBB,0xB0,0xAA,0x9A,0x88,0x88,0x78,0x77,0x77,0x77,0x77,0x77,0x77,0x77,0x88,0x08,0xEC,0x44,0x00,0x21,0x00);
lcm_dcs_write_seq_static(ctx,0xB5,0x22,0x22,0x20,0x11,0x11,0x11,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0xFF);
lcm_dcs_write_seq_static(ctx,0xBA,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x14,0x15,0x16,0x17,0x18,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x0F,0x0F,0x0F,0x19,0x19,0x19,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x03);
lcm_dcs_write_seq_static(ctx,0xB0,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBA,0x00,0xB3,0x00,0xE2,0x00,0x5B,0x03,0x3C,0x03,0x12,0x04,0x69,0x03,0x45,0x03,0x1C,0x04,0x7F,0x03,0x53,0x03,0x2B,0x04,0x9C,0x03,0x67,0x03,0x40,0x04,0xA2,0x03,0x6D,0x03,0x48,0x04,0xA9,0x03,0x74,0x03,0x52,0x04,0xB3,0x03,0x7D,0x03,0x5E,0x04,0xBD,0x03,0x87,0x03,0x6C,0x04,0xC9,0x03,0x93,0x03,0x7C,0x04,0xE7,0x03,0xAA,0x03,0x9E,0x04,0x0A,0x04,0xBD,0x03,0xC0,0x04,0x35,0x04,0xD3,0x03,0xE8,0x04,0x7B,0x04,0xFE,0x03,0x2E,0x05,0xBA,0x04,0x2B,0x04,0x70,0x05,0xEB,0x04,0x52,0x04,0xA4,0x05,0x1E,0x05,0x7B,0x04,0xDB,0x05,0x50,0x05,0xA6,0x04,0x10,0x06,0x77,0x05,0xC8,0x04,0x3B,0x06,0x9F,0x05,0xEB,0x04,0x66,0x06,0xC3,0x05,0x0C,0x05,0x8F,0x06,0xE7,0x05,0x2A,0x05,0xB7,0x06,0x0B,0x06,0x49,0x05,0xDE,0x06,0x2B,0x06,0x67,0x05,0x02,0x07,0x4A,0x06,0x82,0x05,0x24,0x07);
lcm_dcs_write_seq_static(ctx,0xB1,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x4A,0x00,0x47,0x00,0x5A,0x00,0x5A,0x03,0x3B,0x03,0x11,0x04,0x81,0x03,0x55,0x03,0x2C,0x04,0xA4,0x03,0x6E,0x03,0x4A,0x04,0xB7,0x03,0x81,0x03,0x64,0x04,0xD2,0x03,0x9C,0x03,0x87,0x04,0xF5,0x03,0xB2,0x03,0xAC,0x04,0x20,0x04,0xC8,0x03,0xD4,0x04,0x52,0x04,0xE3,0x03,0x04,0x05,0x73,0x04,0xF8,0x03,0x25,0x05,0x93,0x04,0x0F,0x04,0x47,0x05,0xD1,0x04,0x3E,0x04,0x89,0x05,0x0B,0x05,0x6C,0x04,0xC8,0x05,0x3F,0x05,0x98,0x04,0xFF,0x05,0x9B,0x05,0xE7,0x04,0x61,0x06,0xEA,0x05,0x2D,0x05,0xBA,0x06,0x35,0x06,0x6F,0x05,0x0C,0x07,0x74,0x06,0xA9,0x05,0x53,0x07,0xB1,0x06,0xE1,0x05,0x98,0x07,0xEB,0x06,0x16,0x06,0xD9,0x07,0x1D,0x07,0x45,0x06,0x11,0x08,0x4C,0x07,0x70,0x06,0x46,0x08,0x79,0x07,0x9A,0x06,0x7A,0x08,0xAA,0x07,0xC8,0x06,0xB2,0x08,0xD4,0x07,0xEE,0x06,0xE2,0x08,0xFC,0x07,0x13,0x07,0x0F,0x09);
lcm_dcs_write_seq_static(ctx,0xB2,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0xDF,0x00,0xD7,0x00,0x0F,0x01,0x65,0x03,0x42,0x03,0x19,0x04,0xA2,0x03,0x6D,0x03,0x48,0x04,0xC2,0x03,0x8C,0x03,0x72,0x04,0xF3,0x03,0xB1,0x03,0xA9,0x04,0x36,0x04,0xD4,0x03,0xE9,0x04,0x72,0x04,0xF8,0x03,0x24,0x05,0xA4,0x04,0x1C,0x04,0x59,0x05,0xD1,0x04,0x3E,0x04,0x89,0x05,0xFD,0x04,0x61,0x04,0xB8,0x05,0x25,0x05,0x82,0x04,0xE3,0x05,0x70,0x05,0xC2,0x04,0x34,0x06,0xB0,0x05,0xFA,0x04,0x79,0x06,0xEC,0x05,0x2F,0x05,0xBD,0x06,0x57,0x06,0x8E,0x05,0x33,0x07,0xB5,0x06,0xE4,0x05,0x9C,0x07,0x07,0x07,0x30,0x06,0xF9,0x07,0x50,0x07,0x74,0x06,0x4B,0x08,0x97,0x07,0xB6,0x06,0x9C,0x08,0xD9,0x07,0xF3,0x06,0xE8,0x08,0x18,0x08,0x2C,0x07,0x2F,0x09,0x53,0x08,0x60,0x07,0x72,0x09,0x8E,0x08,0x92,0x07,0xB5,0x09,0xC4,0x08,0xC1,0x07,0xF0,0x09,0xFB,0x08,0xF2,0x07,0x2E,0x0A,0x2D,0x09,0x1E,0x08,0x66,0x0A);
lcm_dcs_write_seq_static(ctx,0xB3,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x2A,0x01,0x1F,0x01,0x6A,0x01,0x6C,0x03,0x47,0x03,0x1E,0x04,0xAA,0x03,0x74,0x03,0x52,0x04,0xD6,0x03,0x9F,0x03,0x8C,0x04,0x1A,0x04,0xC5,0x03,0xCE,0x04,0x69,0x04,0xF1,0x03,0x1A,0x05,0xA1,0x04,0x1A,0x04,0x56,0x05,0xD6,0x04,0x42,0x04,0x8E,0x05,0x0A,0x05,0x6B,0x04,0xC6,0x05,0x37,0x05,0x91,0x04,0xF6,0x05,0x64,0x05,0xB7,0x04,0x26,0x06,0xAE,0x05,0xF9,0x04,0x77,0x06,0xF5,0x05,0x36,0x05,0xC6,0x06,0x36,0x06,0x71,0x05,0x0E,0x07,0xA6,0x06,0xD6,0x05,0x8B,0x07,0x06,0x07,0x2F,0x06,0xF8,0x07,0x5A,0x07,0x7D,0x06,0x56,0x08,0xAF,0x07,0xCD,0x06,0xB8,0x08,0xF6,0x07,0x0E,0x07,0x09,0x09,0x3F,0x08,0x4F,0x07,0x5B,0x09,0x82,0x08,0x88,0x07,0xA7,0x09,0xC3,0x08,0xC0,0x07,0xEF,0x09,0x03,0x09,0xF9,0x07,0x36,0x0A,0x3C,0x09,0x2B,0x08,0x78,0x0A,0x76,0x09,0x5E,0x08,0xBA,0x0A,0xAE,0x09,0x90,0x08,0xF9,0x0A);
lcm_dcs_write_seq_static(ctx,0xB4,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x75,0x01,0x67,0x01,0xC4,0x01,0x73,0x03,0x4B,0x03,0x23,0x04,0xB1,0x03,0x7B,0x03,0x5C,0x04,0xEA,0x03,0xAC,0x03,0xA1,0x04,0x41,0x04,0xDA,0x03,0xF4,0x04,0x88,0x04,0x07,0x04,0x3B,0x05,0xC8,0x04,0x36,0x04,0x7F,0x05,0x00,0x05,0x63,0x04,0xBB,0x05,0x34,0x05,0x8F,0x04,0xF3,0x05,0x66,0x05,0xB9,0x04,0x29,0x06,0x92,0x05,0xDF,0x04,0x58,0x06,0xE1,0x05,0x25,0x05,0xB0,0x06,0x2B,0x06,0x67,0x05,0x02,0x07,0x6B,0x06,0xA1,0x05,0x49,0x07,0xE2,0x06,0x0D,0x06,0xCF,0x07,0x44,0x07,0x69,0x06,0x3E,0x08,0xA0,0x07,0xBF,0x06,0xA7,0x08,0xF3,0x07,0x0B,0x07,0x05,0x09,0x44,0x08,0x53,0x07,0x61,0x09,0x91,0x08,0x95,0x07,0xB8,0x09,0xD7,0x08,0xD2,0x07,0x05,0x0A,0x1C,0x09,0x0F,0x08,0x53,0x0A,0x5E,0x09,0x4A,0x08,0xA0,0x0A,0x9C,0x09,0x80,0x08,0xE5,0x0A,0xDA,0x09,0xB6,0x08,0x2B,0x0B,0x17,0x0A,0xEA,0x08,0x72,0x0B);
lcm_dcs_write_seq_static(ctx,0xB5,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0xE4,0x01,0xD3,0x01,0x4C,0x02,0x7A,0x03,0x50,0x03,0x28,0x04,0xB8,0x03,0x83,0x03,0x66,0x04,0xFE,0x03,0xB6,0x03,0xB4,0x04,0x62,0x04,0xEC,0x03,0x13,0x05,0xA7,0x04,0x1E,0x04,0x5C,0x05,0xE5,0x04,0x4E,0x04,0x9F,0x05,0x22,0x05,0x7F,0x04,0xDF,0x05,0x5C,0x05,0xB0,0x04,0x1D,0x06,0x8A,0x05,0xD9,0x04,0x50,0x06,0xB6,0x05,0x00,0x05,0x80,0x06,0x0C,0x06,0x4A,0x05,0xE0,0x06,0x55,0x06,0x8D,0x05,0x31,0x07,0x9C,0x06,0xCE,0x05,0x81,0x07,0x11,0x07,0x3A,0x06,0x04,0x08,0x76,0x07,0x98,0x06,0x77,0x08,0xD9,0x07,0xF3,0x06,0xE7,0x08,0x33,0x08,0x45,0x07,0x4E,0x09,0x85,0x08,0x8B,0x07,0xAA,0x09,0xD3,0x08,0xCF,0x07,0x01,0x0A,0x1F,0x09,0x11,0x08,0x56,0x0A,0x67,0x09,0x51,0x08,0xAA,0x0A,0xAB,0x09,0x8D,0x08,0xF6,0x0A,0xEE,0x09,0xC7,0x08,0x42,0x0B,0x30,0x0A,0xFF,0x08,0x8E,0x0B,0x71,0x0A,0x37,0x09,0xD9,0x0B);
lcm_dcs_write_seq_static(ctx,0xB6,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x2F,0x02,0x1B,0x02,0xA6,0x02,0x81,0x03,0x55,0x03,0x2D,0x04,0xC0,0x03,0x8A,0x03,0x6F,0x04,0x11,0x04,0xC1,0x03,0xC6,0x04,0x74,0x04,0xF9,0x03,0x26,0x05,0xC1,0x04,0x31,0x04,0x77,0x05,0x03,0x05,0x65,0x04,0xBE,0x05,0x41,0x05,0x99,0x04,0x01,0x06,0x78,0x05,0xC8,0x04,0x3B,0x06,0xA9,0x05,0xF4,0x04,0x71,0x06,0xD8,0x05,0x1E,0x05,0xA6,0x06,0x30,0x06,0x6B,0x05,0x07,0x07,0x7B,0x06,0xB0,0x05,0x5C,0x07,0xC1,0x06,0xEF,0x05,0xAA,0x07,0x3C,0x07,0x61,0x06,0x34,0x08,0xA9,0x07,0xC7,0x06,0xB0,0x08,0x09,0x08,0x1F,0x07,0x1E,0x09,0x65,0x08,0x6F,0x07,0x86,0x09,0xBD,0x08,0xBB,0x07,0xE8,0x09,0x10,0x09,0x04,0x08,0x45,0x0A,0x5E,0x09,0x49,0x08,0x9F,0x0A,0xA7,0x09,0x8A,0x08,0xF2,0x0A,0xEF,0x09,0xC8,0x08,0x44,0x0B,0x36,0x0A,0x04,0x09,0x95,0x0B,0x7C,0x0A,0x40,0x09,0xE6,0x0B,0xC3,0x0A,0x7B,0x09,0x36,0x0C);
lcm_dcs_write_seq_static(ctx,0xB7,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x7A,0x02,0x63,0x02,0x01,0x03,0x88,0x03,0x5A,0x03,0x32,0x04,0xC7,0x03,0x91,0x03,0x79,0x04,0x25,0x04,0xCB,0x03,0xD9,0x04,0x86,0x04,0x06,0x04,0x3A,0x05,0xD4,0x04,0x40,0x04,0x8C,0x05,0x1B,0x05,0x79,0x04,0xD8,0x05,0x5D,0x05,0xB1,0x04,0x1E,0x06,0x93,0x05,0xE0,0x04,0x59,0x06,0xC5,0x05,0x0D,0x05,0x91,0x06,0xF6,0x05,0x37,0x05,0xC7,0x06,0x4E,0x06,0x86,0x05,0x28,0x07,0x9F,0x06,0xD0,0x05,0x83,0x07,0xE5,0x06,0x11,0x06,0xD3,0x07,0x5D,0x07,0x80,0x06,0x5A,0x08,0xD0,0x07,0xEB,0x06,0xDD,0x08,0x37,0x08,0x48,0x07,0x52,0x09,0x97,0x08,0x9A,0x07,0xBE,0x09,0xEF,0x08,0xE8,0x07,0x20,0x0A,0x43,0x09,0x31,0x08,0x80,0x0A,0x93,0x09,0x78,0x08,0xDB,0x0A,0xE1,0x09,0xBC,0x08,0x33,0x0B,0x2D,0x0A,0xFD,0x08,0x8B,0x0B,0x78,0x0A,0x3D,0x09,0xE1,0x0B,0xC3,0x0A,0x7B,0x09,0x37,0x0C,0x0B,0x0B,0xB7,0x09,0x89,0x0C);
lcm_dcs_write_seq_static(ctx,0xB8,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0xC4,0x02,0xAB,0x02,0x5B,0x03,0x8F,0x03,0x5E,0x03,0x37,0x04,0xCF,0x03,0x98,0x03,0x83,0x04,0x39,0x04,0xD6,0x03,0xEC,0x04,0x99,0x04,0x14,0x04,0x4D,0x05,0xE8,0x04,0x50,0x04,0xA1,0x05,0x31,0x05,0x8B,0x04,0xEF,0x05,0x71,0x05,0xC3,0x04,0x34,0x06,0xA9,0x05,0xF4,0x04,0x72,0x06,0xDE,0x05,0x23,0x05,0xAD,0x06,0x11,0x06,0x4F,0x05,0xE5,0x06,0x69,0x06,0x9F,0x05,0x47,0x07,0xBA,0x06,0xE9,0x05,0xA2,0x07,0x02,0x07,0x2B,0x06,0xF3,0x07,0x7F,0x07,0xA0,0x06,0x81,0x08,0xF3,0x07,0x0A,0x07,0x05,0x09,0x5C,0x08,0x68,0x07,0x7C,0x09,0xBF,0x08,0xBD,0x07,0xEB,0x09,0x1C,0x09,0x0F,0x08,0x53,0x0A,0x73,0x09,0x5B,0x08,0xB7,0x0A,0xC6,0x09,0xA5,0x08,0x15,0x0B,0x17,0x0A,0xEA,0x08,0x72,0x0B,0x66,0x0A,0x2E,0x09,0xCD,0x0B,0xB5,0x0A,0x6F,0x09,0x27,0x0C,0x02,0x0B,0xAF,0x09,0x7E,0x0C,0x4E,0x0B,0xED,0x09,0xD5,0x0C);
lcm_dcs_write_seq_static(ctx,0xB9,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x5A,0x03,0x3B,0x03,0x11,0x04,0x9C,0x03,0x67,0x03,0x40,0x04,0xDC,0x03,0xA5,0x03,0x94,0x04,0x5C,0x04,0xE8,0x03,0x0D,0x05,0xB9,0x04,0x2B,0x04,0x6F,0x05,0x0A,0x05,0x6B,0x04,0xC6,0x05,0x57,0x05,0xAC,0x04,0x18,0x06,0x95,0x05,0xE2,0x04,0x5B,0x06,0xCF,0x05,0x16,0x05,0x9C,0x06,0x07,0x06,0x46,0x05,0xDA,0x06,0x3B,0x06,0x75,0x05,0x13,0x07,0x98,0x06,0xCA,0x05,0x7C,0x07,0xE9,0x06,0x14,0x06,0xD7,0x07,0x33,0x07,0x59,0x06,0x2A,0x08,0xB9,0x07,0xD6,0x06,0xC3,0x08,0x2F,0x08,0x41,0x07,0x49,0x09,0x9D,0x08,0x9F,0x07,0xC5,0x09,0x03,0x09,0xF9,0x07,0x36,0x0A,0x62,0x09,0x4D,0x08,0xA4,0x0A,0xBD,0x09,0x9D,0x08,0x0A,0x0B,0x15,0x0A,0xE8,0x08,0x6F,0x0B,0x6B,0x0A,0x32,0x09,0xD2,0x0B,0xC1,0x0A,0x79,0x09,0x34,0x0C,0x14,0x0B,0xBE,0x09,0x93,0x0C,0x67,0x0B,0x02,0x0A,0xF1,0x0C,0xBA,0x0B,0x44,0x0A,0x52,0x0D);
lcm_dcs_write_seq_static(ctx,0xBD,0x00,0x00,0xFF,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0xA3,0x06,0x12,0x06,0xFF,0x06,0xA3,0x06,0x12,0x06,0xFF,0x06,0xF3,0x06,0x76,0x06,0x63,0x07,0x1C,0x07,0xA0,0x06,0x92,0x07,0x45,0x07,0xDD,0x06,0xBA,0x07,0x72,0x07,0x09,0x07,0xF9,0x07,0x91,0x07,0x1E,0x07,0x17,0x08,0xC4,0x07,0x4B,0x07,0x4C,0x08,0xEE,0x07,0x6F,0x07,0x76,0x08,0x13,0x08,0x90,0x07,0x9E,0x08,0x36,0x08,0xAF,0x07,0xC3,0x08,0x7F,0x08,0xF2,0x07,0x10,0x09,0xB4,0x08,0x22,0x08,0x4B,0x09,0xE9,0x08,0x52,0x08,0x86,0x09,0x49,0x09,0xAD,0x08,0xF1,0x09,0x97,0x09,0xF5,0x08,0x48,0x0A,0xDD,0x09,0x36,0x09,0x96,0x0A,0x1D,0x0A,0x71,0x09,0xDD,0x0A,0x54,0x0A,0xA4,0x09,0x1A,0x0B,0x8A,0x0A,0xD6,0x09,0x57,0x0B,0xBE,0x0A,0x05,0x0A,0x91,0x0B,0xF0,0x0A,0x32,0x0A,0xCA,0x0B,0x1B,0x0B,0x58,0x0A,0xFA,0x0B,0x48,0x0B,0x80,0x0A,0x2D,0x0C,0x74,0x0B,0xA7,0x0A,0x5F,0x0C,0x99,0x0B,0xC7,0x0A,0x8B,0x0C);
lcm_dcs_write_seq_static(ctx,0xBE,0x00,0x00,0xFF,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0xA3,0x06,0x12,0x06,0xFF,0x06,0xA3,0x06,0x12,0x06,0xFF,0x06,0xF3,0x06,0x76,0x06,0x63,0x07,0x1C,0x07,0xA0,0x06,0x92,0x07,0x45,0x07,0xDD,0x06,0xBA,0x07,0x72,0x07,0x09,0x07,0xF9,0x07,0x91,0x07,0x1E,0x07,0x17,0x08,0xC4,0x07,0x4B,0x07,0x4C,0x08,0xEE,0x07,0x6F,0x07,0x76,0x08,0x13,0x08,0x90,0x07,0x9E,0x08,0x36,0x08,0xAF,0x07,0xC3,0x08,0x7F,0x08,0xF2,0x07,0x10,0x09,0xB4,0x08,0x22,0x08,0x4B,0x09,0xE9,0x08,0x52,0x08,0x86,0x09,0x49,0x09,0xAD,0x08,0xF1,0x09,0x97,0x09,0xF5,0x08,0x48,0x0A,0xDD,0x09,0x36,0x09,0x96,0x0A,0x1D,0x0A,0x71,0x09,0xDD,0x0A,0x54,0x0A,0xA4,0x09,0x1A,0x0B,0x8A,0x0A,0xD6,0x09,0x57,0x0B,0xBE,0x0A,0x05,0x0A,0x91,0x0B,0xF0,0x0A,0x32,0x0A,0xCA,0x0B,0x1B,0x0B,0x58,0x0A,0xFA,0x0B,0x48,0x0B,0x80,0x0A,0x2D,0x0C,0x74,0x0B,0xA7,0x0A,0x5F,0x0C,0x99,0x0B,0xC7,0x0A,0x8B,0x0C);
lcm_dcs_write_seq_static(ctx,0xBF,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0xA3,0x06,0x12,0x06,0xFF,0x06,0xA3,0x06,0x12,0x06,0xFF,0x06,0xF3,0x06,0x76,0x06,0x63,0x07,0x1C,0x07,0xA0,0x06,0x92,0x07,0x45,0x07,0xDD,0x06,0xBA,0x07,0x72,0x07,0x09,0x07,0xF9,0x07,0x91,0x07,0x1E,0x07,0x17,0x08,0xC4,0x07,0x4B,0x07,0x4C,0x08,0xEE,0x07,0x6F,0x07,0x76,0x08,0x13,0x08,0x90,0x07,0x9E,0x08,0x36,0x08,0xAF,0x07,0xC3,0x08,0x7F,0x08,0xF2,0x07,0x10,0x09,0xB4,0x08,0x22,0x08,0x4B,0x09,0xE9,0x08,0x52,0x08,0x86,0x09,0x49,0x09,0xAD,0x08,0xF1,0x09,0x97,0x09,0xF5,0x08,0x48,0x0A,0xDD,0x09,0x36,0x09,0x96,0x0A,0x1D,0x0A,0x71,0x09,0xDD,0x0A,0x54,0x0A,0xA4,0x09,0x1A,0x0B,0x8A,0x0A,0xD6,0x09,0x57,0x0B,0xBE,0x0A,0x05,0x0A,0x91,0x0B,0xF0,0x0A,0x32,0x0A,0xCA,0x0B,0x1B,0x0B,0x58,0x0A,0xFA,0x0B,0x48,0x0B,0x80,0x0A,0x2D,0x0C,0x74,0x0B,0xA7,0x0A,0x5F,0x0C,0x99,0x0B,0xC7,0x0A,0x8B,0x0C);
lcm_dcs_write_seq_static(ctx,0xBD,0x00,0x00,0xFF,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x04,0x25,0x04,0x2C,0x05,0xD4,0x04,0x89,0x04,0x90,0x05,0x38,0x05,0xED,0x04,0xF4,0x05,0x57,0x05,0x0C,0x05,0x15,0x06,0x9B,0x05,0x3C,0x05,0x44,0x06,0xC7,0x05,0x55,0x05,0x71,0x06,0xE7,0x05,0x60,0x05,0x95,0x06,0x25,0x06,0x92,0x05,0xD3,0x06,0x54,0x06,0xB7,0x05,0x04,0x07,0x7F,0x06,0xDA,0x05,0x32,0x07,0xA9,0x06,0xFC,0x05,0x5F,0x07,0xF9,0x06,0x43,0x06,0xB4,0x07,0x39,0x07,0x7D,0x06,0xFC,0x07,0x76,0x07,0xB3,0x06,0x3E,0x08,0xE6,0x07,0x19,0x07,0xBC,0x08,0x41,0x08,0x6D,0x07,0x22,0x09,0x93,0x08,0xB8,0x07,0x7F,0x09,0xDE,0x08,0xFB,0x07,0xD4,0x09,0x21,0x09,0x38,0x08,0x20,0x0A,0x64,0x09,0x73,0x08,0x69,0x0A,0xA1,0x09,0xAA,0x08,0xAF,0x0A,0xDC,0x09,0xDE,0x08,0xF0,0x0A,0x12,0x0A,0x0E,0x09,0x2F,0x0B,0x48,0x0A,0x3E,0x09,0x6D,0x0B,0x7C,0x0A,0x6C,0x09,0xA7,0x0B,0xAC,0x0A,0x95,0x09,0xE2,0x0B);
lcm_dcs_write_seq_static(ctx,0xBE,0x00,0x00,0xFF,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x04,0x25,0x04,0x2C,0x05,0xD4,0x04,0x89,0x04,0x90,0x05,0x38,0x05,0xED,0x04,0xF4,0x05,0x57,0x05,0x0C,0x05,0x15,0x06,0x9B,0x05,0x3C,0x05,0x44,0x06,0xC7,0x05,0x55,0x05,0x71,0x06,0xE7,0x05,0x60,0x05,0x95,0x06,0x25,0x06,0x92,0x05,0xD3,0x06,0x54,0x06,0xB7,0x05,0x04,0x07,0x7F,0x06,0xDA,0x05,0x32,0x07,0xA9,0x06,0xFC,0x05,0x5F,0x07,0xF9,0x06,0x43,0x06,0xB4,0x07,0x39,0x07,0x7D,0x06,0xFC,0x07,0x76,0x07,0xB3,0x06,0x3E,0x08,0xE6,0x07,0x19,0x07,0xBC,0x08,0x41,0x08,0x6D,0x07,0x22,0x09,0x93,0x08,0xB8,0x07,0x7F,0x09,0xDE,0x08,0xFB,0x07,0xD4,0x09,0x21,0x09,0x38,0x08,0x20,0x0A,0x64,0x09,0x73,0x08,0x69,0x0A,0xA1,0x09,0xAA,0x08,0xAF,0x0A,0xDC,0x09,0xDE,0x08,0xF0,0x0A,0x12,0x0A,0x0E,0x09,0x2F,0x0B,0x48,0x0A,0x3E,0x09,0x6D,0x0B,0x7C,0x0A,0x6C,0x09,0xA7,0x0B,0xAC,0x0A,0x95,0x09,0xE2,0x0B);
lcm_dcs_write_seq_static(ctx,0xBF,0x00,0x00,0xFF,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x04,0x25,0x04,0x2C,0x05,0xD4,0x04,0x89,0x04,0x90,0x05,0x38,0x05,0xED,0x04,0xF4,0x05,0x57,0x05,0x0C,0x05,0x15,0x06,0x9B,0x05,0x3C,0x05,0x44,0x06,0xC7,0x05,0x55,0x05,0x71,0x06,0xE7,0x05,0x60,0x05,0x95,0x06,0x25,0x06,0x92,0x05,0xD3,0x06,0x54,0x06,0xB7,0x05,0x04,0x07,0x7F,0x06,0xDA,0x05,0x32,0x07,0xA9,0x06,0xFC,0x05,0x5F,0x07,0xF9,0x06,0x43,0x06,0xB4,0x07,0x39,0x07,0x7D,0x06,0xFC,0x07,0x76,0x07,0xB3,0x06,0x3E,0x08,0xE6,0x07,0x19,0x07,0xBC,0x08,0x41,0x08,0x6D,0x07,0x22,0x09,0x93,0x08,0xB8,0x07,0x7F,0x09,0xDE,0x08,0xFB,0x07,0xD4,0x09,0x21,0x09,0x38,0x08,0x20,0x0A,0x64,0x09,0x73,0x08,0x69,0x0A,0xA1,0x09,0xAA,0x08,0xAF,0x0A,0xDC,0x09,0xDE,0x08,0xF0,0x0A,0x12,0x0A,0x0E,0x09,0x2F,0x0B,0x48,0x0A,0x3E,0x09,0x6D,0x0B,0x7C,0x0A,0x6C,0x09,0xA7,0x0B,0xAC,0x0A,0x95,0x09,0xE2,0x0B);
lcm_dcs_write_seq_static(ctx,0xBA,0x00,0x00,0xFF,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x6B,0x02,0x24,0x02,0xD7,0x02,0x01,0x03,0xBE,0x02,0x90,0x03,0x3F,0x03,0xFE,0x02,0xD2,0x03,0x94,0x03,0x3A,0x03,0x27,0x04,0xE4,0x03,0x74,0x03,0x7C,0x04,0x28,0x04,0xA8,0x03,0xC4,0x04,0x68,0x04,0xDE,0x03,0x09,0x05,0xA0,0x04,0x0F,0x04,0x46,0x05,0xCF,0x04,0x38,0x04,0x7A,0x05,0xFE,0x04,0x62,0x04,0xAE,0x05,0x27,0x05,0x88,0x04,0xDE,0x05,0x70,0x05,0xCA,0x04,0x30,0x06,0xB6,0x05,0x09,0x05,0x7E,0x06,0xF5,0x05,0x42,0x05,0xC5,0x06,0x62,0x06,0xA5,0x05,0x40,0x07,0xC7,0x06,0x00,0x06,0xB1,0x07,0x21,0x07,0x51,0x06,0x18,0x08,0x75,0x07,0x9B,0x06,0x78,0x08,0xC4,0x07,0xE2,0x06,0xD3,0x08,0x11,0x08,0x25,0x07,0x2C,0x09,0x5B,0x08,0x65,0x07,0x7F,0x09,0xA3,0x08,0xA1,0x07,0xD1,0x09,0xEB,0x08,0xDC,0x07,0x21,0x0A,0x31,0x09,0x15,0x08,0x70,0x0A,0x76,0x09,0x4F,0x08,0xBC,0x0A,0xBA,0x09,0x87,0x08,0x0B,0x0B);
lcm_dcs_write_seq_static(ctx,0xBB,0x00,0x00,0xFF,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0xD7,0x02,0x84,0x02,0x56,0x03,0x0B,0x03,0xCB,0x02,0x9E,0x03,0x4C,0x03,0x0B,0x03,0xDF,0x03,0xAE,0x03,0x4B,0x03,0x41,0x04,0x00,0x04,0x89,0x03,0x9A,0x04,0x44,0x04,0xBF,0x03,0xE2,0x04,0x8B,0x04,0xFD,0x03,0x2E,0x05,0xBD,0x04,0x28,0x04,0x65,0x05,0xF1,0x04,0x56,0x04,0x9F,0x05,0x1F,0x05,0x81,0x04,0xD4,0x05,0x49,0x05,0xA6,0x04,0x04,0x06,0x98,0x05,0xEE,0x04,0x5D,0x06,0xDE,0x05,0x2D,0x05,0xAC,0x06,0x1F,0x06,0x69,0x05,0xF5,0x06,0x94,0x06,0xD2,0x05,0x78,0x07,0xFA,0x06,0x2E,0x06,0xEB,0x07,0x57,0x07,0x81,0x06,0x56,0x08,0xAD,0x07,0xCE,0x06,0xB9,0x08,0x02,0x08,0x18,0x07,0x1A,0x09,0x52,0x08,0x5D,0x07,0x75,0x09,0xA0,0x08,0x9E,0x07,0xCD,0x09,0xEE,0x08,0xDE,0x07,0x24,0x0A,0x3A,0x09,0x1D,0x08,0x7A,0x0A,0x85,0x09,0x5C,0x08,0xCD,0x0A,0xCF,0x09,0x98,0x08,0x23,0x0B,0x1B,0x0A,0xD5,0x08,0x79,0x0B);
lcm_dcs_write_seq_static(ctx,0xE4,0x00,0x00,0xFF,0x06,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00,0xFF,0x00,0xFF,0x08,0xFF,0x00);
lcm_dcs_write_seq_static(ctx,0xE4,0x00,0x00,0xFF,0x07,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00,0xFF,0x00,0xac,0x0d,0xFF,0x00);
lcm_dcs_write_seq_static(ctx,0xE4,0x00,0x00,0xFF,0x07,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00,0xFF,0x00,0x98,0x08,0xFF,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x04);
lcm_dcs_write_seq_static(ctx,0xB2,0x00,0x0A,0x77,0x66,0x55,0x44,0x33,0x22,0x11,0x11,0x10,0x00,0x00,0x00,0x00,0x00,0xFF,0x7E,0xFE,0x7E,0xFD,0x7D,0xFD,0x7D,0xFC,0x7C,0xFC,0x7C,0xFB,0xBB,0x7B,0x3A,0x1A,0xFA,0xDA,0xBB,0x99,0x79,0x59,0x38,0x18,0x08,0xFE);
lcm_dcs_write_seq_static(ctx,0xB3,0x0A,0x02,0x3A,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x05);
lcm_dcs_write_seq_static(ctx,0xB1,0xF0,0x01,0xC4,0x07,0xE3,0x02,0x7A,0x08,0x9A,0x47,0x01,0xF4,0x01,0xF4,0x01,0xF4,0x00,0x00,0x07,0xA7,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB2,0x0C,0xD6,0x01,0xD0,0x07,0x05,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x0A);
lcm_dcs_write_seq_static(ctx,0xB0,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x0E);
lcm_dcs_write_seq_static(ctx,0xB0,0x33,0x00,0x60,0x09,0x38,0x04);
lcm_dcs_write_seq_static(ctx,0xB1,0x55,0x00,0x00,0x00,0x44,0x00,0x44,0x40,0x04,0x40,0x04,0x40,0x04,0x19,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB2,0x41,0x34,0x00,0xf3,0x37,0x00,0x44,0x30,0x3f,0x40,0x04,0x40,0x04,0x19,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB3,0x49,0x00,0x99,0x00,0x48,0x17,0x5f,0x80,0x04,0x70,0x91,0x80,0x04,0x19,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB4,0x4d,0x34,0x99,0xef,0x37,0x17,0x5f,0xf0,0x3e,0x70,0x91,0x80,0x04,0x19,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB5,0x03,0x12,0x00,0xf4,0x44,0x0f,0x55,0xc0,0x21,0x20,0x03,0xe0,0x01,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB6,0x10,0x22,0x00,0x99,0xab,0x00,0x12,0xb0,0x2a,0x20,0x01,0x20,0x01,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB7,0x4a,0x11,0x00,0x9d,0xdc,0x12,0x52,0xc0,0x1d,0x20,0x01,0xe0,0x03,0x0a,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB8,0x42,0x22,0x00,0x5c,0x9a,0x12,0x52,0xc0,0x25,0x20,0x01,0xe0,0x03,0x0a,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB9,0x84,0x12,0x00,0xc8,0x1b,0x00,0x14,0x70,0x1c,0x50,0x01,0x60,0x01,0x01,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBA,0x88,0x22,0x00,0x1c,0x6f,0x00,0x14,0xf0,0x26,0x40,0x01,0x50,0x01,0x01,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBB,0x03,0x03,0x00,0x45,0xf2,0x00,0x00,0x01,0x10,0x10,0x10,0x00,0x00,0x00,0x05,0x00,0x09,0x00,0x00,0x45,0x16,0x01,0x10,0x10,0x10,0x00,0x00,0x00,0x07,0x44,0x09,0x37,0x37,0x45,0x16,0x01,0x10,0x10,0x10,0x00,0x00,0x00,0x01,0x03,0x99,0x49,0xee,0x5f,0x5f,0x01,0x10,0x10,0x10,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBC,0x02,0x12,0x00,0xdd,0x5b,0x51,0x51,0x01,0x20,0x20,0x20,0x20,0x20,0x20,0x12,0x00,0x11,0xbe,0xd2,0x36,0x36,0xaa,0x20,0x20,0x20,0x20,0x20,0x20,0x02,0x00,0x11,0xbe,0xd2,0x40,0x40,0xff,0x20,0x20,0x00,0x00,0x00,0x00,0x12,0x00,0x11,0xbe,0xd2,0x4a,0x4a,0xff,0x20,0x20,0x20,0x20,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBD,0x00,0x04,0xaa,0xa3,0x0c,0x4f,0x4f,0x01,0x10,0x10,0x10,0x00,0x00,0x00,0x16,0x44,0x09,0xaf,0xaf,0xb5,0xa2,0x01,0x10,0x10,0x10,0x00,0x00,0x00,0x02,0x00,0x11,0xbe,0xd2,0x68,0x68,0xed,0x10,0x10,0x20,0x20,0x10,0x10,0x06,0x11,0x00,0xf4,0xf4,0xbe,0xd2,0xff,0x80,0x10,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xBE,0x02,0x04,0x00,0x00,0xf0,0x00,0x00,0x01,0x80,0x00,0x80,0x00,0x80,0x00,0x00,0x04,0x55,0x00,0xf0,0xff,0xff,0x01,0x80,0x00,0x80,0x00,0x80,0x00,0x04,0x55,0x05,0x03,0x03,0x13,0xec,0x01,0x40,0x00,0x80,0x00,0x80,0x00,0x06,0x22,0x00,0x1c,0x1c,0xbe,0xd2,0xeb,0x0c,0x20,0x80,0x10,0x0e,0x0d);
lcm_dcs_write_seq_static(ctx,0xBF,0x16,0x22,0x00,0x26,0x26,0xbe,0xd2,0x9c,0x13,0x40,0x25,0x0f,0x63,0x21,0x06,0x22,0x00,0x30,0x30,0xbe,0xd2,0xff,0x21,0x10,0x42,0x10,0x63,0x10,0x02,0x00,0x00,0x64,0x64,0xf9,0xf9,0xff,0x20,0x20,0x20,0x20,0x20,0x20,0x12,0x00,0x00,0x6e,0x6e,0xf9,0xf9,0xff,0x20,0x20,0x20,0x20,0x20,0x20);
lcm_dcs_write_seq_static(ctx,0xC0,0x12,0x11,0x00,0x2c,0x2c,0xf7,0xf7,0xff,0x40,0x10,0x40,0x20,0x40,0x10,0x02,0x11,0x00,0x36,0x36,0xf7,0xf7,0xff,0x14,0x20,0x14,0x10,0x14,0x20,0x16,0x33,0x00,0x1b,0x1b,0xc8,0xc8,0xff,0x20,0x20,0x20,0x20,0x20,0x20,0x14,0x33,0x00,0x1b,0x1b,0xd2,0xd2,0xff,0x20,0x20,0x20,0x20,0x20,0x20);
lcm_dcs_write_seq_static(ctx,0xC1,0x00,0x01,0x02,0x03,0x04,0x06,0x07,0x08,0x09,0x0a,0x0c,0x0d,0x0e,0x0f,0x10,0x12,0x13,0x14,0x15,0x16,0x18,0x19,0x1a,0x1b,0x1c,0x1e,0x1f,0x20,0x21,0x22,0x24,0x25,0x26,0x27,0x28,0x2a,0x2b,0x2c,0x2d,0x2e,0x30,0x31,0x32,0x33,0x34,0x36,0x37,0x38,0x39,0x3a,0x3c,0x3d,0x3e,0x3f,0x40,0x42,0x43,0x44,0x45,0x46,0x48,0x49,0x4a,0x4b);
lcm_dcs_write_seq_static(ctx,0xC2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xC3,0x00,0x02,0x05,0x08,0x0b,0x0e,0x10,0x13,0x16,0x19,0x1c,0x1e,0x21,0x24,0x27,0x2a,0x2c,0x2f,0x32,0x35,0x38,0x3a,0x3d,0x40,0x43,0x46,0x48,0x4b,0x4e,0x51,0x54,0x56,0x59,0x5c,0x5f,0x62,0x64,0x67,0x6a,0x6d,0x70,0x72,0x75,0x78,0x7b,0x7d,0x80,0x83,0x86,0x89,0x8c,0x8e,0x91,0x94,0x97,0x9a,0x9c,0x9f,0xa2,0xa5,0xa8,0xaa,0xad,0xb0);
lcm_dcs_write_seq_static(ctx,0xC4,0x00,0x03,0x07,0x0a,0x0e,0x12,0x15,0x19,0x1c,0x20,0x24,0x27,0x2b,0x2e,0x32,0x36,0x39,0x3d,0x40,0x44,0x48,0x4b,0x4f,0x52,0x56,0x5a,0x5d,0x61,0x64,0x68,0x6c,0x6f,0x73,0x76,0x7a,0x7e,0x81,0x85,0x88,0x8c,0x90,0x93,0x97,0x9a,0x9e,0xa2,0xa5,0xa9,0xac,0xb0,0xb4,0xb7,0xbb,0xbe,0xc2,0xc6,0xc9,0xcd,0xd0,0xd4,0xd8,0xdb,0xdf,0xe2);
lcm_dcs_write_seq_static(ctx,0xC5,0x00,0x04,0x08,0x0c,0x10,0x14,0x18,0x1c,0x20,0x24,0x28,0x2c,0x30,0x34,0x38,0x3c,0x40,0x44,0x48,0x4c,0x50,0x54,0x58,0x5c,0x60,0x64,0x68,0x6c,0x70,0x74,0x78,0x7c,0x80,0x84,0x88,0x8c,0x90,0x94,0x98,0x9c,0xa0,0xa4,0xa8,0xac,0xb0,0xb4,0xb8,0xbc,0xc0,0xc4,0xc8,0xcc,0xd0,0xd4,0xd8,0xdc,0xe0,0xe4,0xe8,0xec,0xf0,0xf4,0xf8,0xfc);
lcm_dcs_write_seq_static(ctx,0xC6,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x09,0x0a,0x0c,0x0d,0x0f,0x11,0x13,0x16,0x18,0x1b,0x1d,0x20,0x23,0x26,0x29,0x2d,0x30,0x34,0x37,0x3b,0x3f,0x44,0x48,0x4d,0x51,0x56,0x5b,0x60,0x65,0x6b,0x70,0x76,0x7c,0x82,0x88,0x8e,0x95,0x9c,0xa2,0xa9,0xb0,0xb8,0xbf,0xc7,0xcf,0xd7,0xdf,0xe7,0xef,0xf8);
lcm_dcs_write_seq_static(ctx,0xC7,0x00,0x26,0x34,0x3f,0x48,0x50,0x57,0x5d,0x63,0x68,0x6d,0x72,0x77,0x7b,0x80,0x84,0x88,0x8b,0x8f,0x93,0x96,0x99,0x9d,0xa0,0xa3,0xa6,0xa9,0xac,0xaf,0xb2,0xb5,0xb7,0xba,0xbd,0xbf,0xc2,0xc4,0xc7,0xc9,0xcb,0xce,0xd0,0xd2,0xd5,0xd7,0xd9,0xdb,0xde,0xe0,0xe2,0xe4,0xe6,0xe8,0xea,0xec,0xee,0xf0,0xf2,0xf4,0xf6,0xf8,0xf9,0xfb,0xfd);
lcm_dcs_write_seq_static(ctx,0xC8,0x00,0x12,0x1d,0x25,0x2d,0x33,0x3a,0x40,0x45,0x4b,0x50,0x55,0x59,0x5e,0x62,0x67,0x6b,0x6f,0x73,0x77,0x7b,0x7f,0x83,0x86,0x8a,0x8e,0x91,0x95,0x98,0x9b,0x9f,0xa2,0xa5,0xa8,0xac,0xaf,0xb2,0xb5,0xb8,0xbb,0xbe,0xc1,0xc4,0xc7,0xca,0xcd,0xcf,0xd2,0xd5,0xd8,0xdb,0xdd,0xe0,0xe3,0xe5,0xe8,0xeb,0xed,0xf0,0xf2,0xf5,0xf8,0xfa,0xfd);
lcm_dcs_write_seq_static(ctx,0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x50,0x55,0x55,0x55,0x55,0x55,0x55,0xaa,0xaa,0xaa,0x00,0x0a,0x14,0x1e,0x28,0x32,0x3c,0x46,0x50,0x5a,0x64,0x6e,0x78,0x82,0x8c,0x96,0xa0,0xaa,0xb4,0xbe,0xc8,0xd2,0xdc,0xe6,0xf0,0xfa,0x04,0x0e,0x18,0x22,0x2c,0x36,0x40,0x4a,0x54,0x5e,0x68,0x72,0x7c,0x86,0x90,0x9a,0xa4,0xae,0xb8,0xc2,0xcc,0xd6,0xe0,0xea,0xf4,0xfe,0x08,0x12,0x1c,0x26,0x30,0x3a,0x44,0x4e,0x58,0x62,0x6c,0x76);
lcm_dcs_write_seq_static(ctx,0xCA,0xaa,0xaa,0xaa,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x8a,0x94,0x9e,0xa8,0xb2,0xbc,0xc6,0xd0,0xda,0xe4,0xee,0xf8,0x02,0x0c,0x16,0x20,0x2a,0x34,0x3e,0x48,0x52,0x5c,0x66,0x70,0x7a,0x84,0x8e,0x98,0xa2,0xac,0xb6,0xc0,0xca,0xd4,0xde,0xe8,0xf2,0xfc,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff);
lcm_dcs_write_seq_static(ctx,0xCB,0xff,0x5a,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xe8,0x84,0x20,0xbc,0x58,0xf4,0x90,0x2c,0xc8,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x04,0x06,0x08,0x0a,0x0c,0x0e,0x10,0x12,0x14,0x16,0x18,0x1a,0x1c,0x1e,0x20,0x22,0x24,0x26,0x28,0x2a,0x2c,0x2e,0x30,0x32,0x34,0x36,0x38,0x3a,0x3c,0x3e);
lcm_dcs_write_seq_static(ctx,0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x0F);
lcm_dcs_write_seq_static(ctx,0xB0,0x00,0x01,0x00,0x64,0x00,0xFA,0x01,0x5E,0x01,0xC2,0x02,0x26,0x02,0x8A,0x02,0xEE,0x03,0x52,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x01,0xFF,0x03,0xFF,0x03,0xFF,0x07,0xFF,0x0F,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF);
lcm_dcs_write_seq_static(ctx,0xB1,0x00,0x00,0x12,0x00,0x72,0x00,0xAD,0x00,0xE8,0x01,0x5F,0x01,0x9A,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x01,0xFF,0x03,0xFF,0x00,0xFF,0x01,0xFF,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x03,0xFF,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB2,0x00,0x00,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x00,0x00,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x00,0x00,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC5,0x09,0xC4,0x09,0xC4,0x00,0x00,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4,0x09,0xC4);
lcm_dcs_write_seq_static(ctx,0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x00,0xC0);
lcm_dcs_write_seq_static(ctx,0xB4,0x01,0x02,0x07,0x01,0x5A,0x50,0x46,0x99,0x03,0x33,0x03,0xCC,0x02,0x33,0x00,0x66,0x00,0x99,0x00);
lcm_dcs_write_seq_static(ctx,0xB5,0x0B,0x03,0x04,0x46,0x00,0x64,0x00,0x32,0x00,0x04,0x04,0x10,0x80,0x21,0x21,0x4C,0x2B,0x00,0x00,0x35,0x01,0x4C,0x00,0x00,0x00,0x00,0x00,0x1F,0x1F,0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x1F,0x02,0x00,0x55,0x55,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB6,0x00,0x01,0x01,0x23,0x45,0x67,0x01,0x23,0x45,0x67,0x05,0x04,0x03,0x02,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x10);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x10);

lcm_dcs_write_seq_static(ctx,0xB0,0x11,0x60,0x09,0x38,0x04,0x0E,0x01,0x00);
lcm_dcs_write_seq_static(ctx,0xB1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xB4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0xFF,0x3C,0x11);
lcm_dcs_write_seq_static(ctx,0xB1,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFB,0xFF,0xFF,0xF9,0xFF,0xFF,0xF3,0xFF,0xFC,0xF0,0xFF,0xFA,0xEC,0xFF,0xF9,0xE7,0xFF,0xF5,0xDA,0xFF,0xEF,0xCB,0xFF,0xE9,0xB7,0xFF,0xDE,0x9D,0xFF,0xCA,0x6F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00);
lcm_dcs_write_seq_static(ctx,0x70,0x00);
lcm_dcs_write_seq_static(ctx,0x03,0x00);
lcm_dcs_write_seq_static(ctx,0x2A,0x00,0x00,0x04,0x37);
lcm_dcs_write_seq_static(ctx,0x2B,0x00,0x00,0x09,0x5F);
lcm_dcs_write_seq_static(ctx,0x44,0x05,0xFF);
lcm_dcs_write_seq_static(ctx,0x35,0x00);
lcm_dcs_write_seq_static(ctx,0x4A,0x00,0x04);
lcm_dcs_write_seq_static(ctx,0x4C,0xFF,0x0F);
lcm_dcs_write_seq_static(ctx,0x51,0x00,0x00);
lcm_dcs_write_seq_static(ctx,0x53,0x21);
lcm_dcs_write_seq_static(ctx,0x7B,0x01);

lcm_dcs_write_seq_static(ctx,0x11);
msleep(70);
lcm_dcs_write_seq_static(ctx,0x29);
msleep(250);

	pr_info("%s-\n", __func__);
}

static int lcm_disable(struct drm_panel *panel)
{
	struct lcm *ctx = panel_to_lcm(panel);

	if (!ctx->enabled)
		return 0;

	if (ctx->backlight) {
		ctx->backlight->props.power = FB_BLANK_POWERDOWN;
		backlight_update_status(ctx->backlight);
	}

	ctx->enabled = false;

	return 0;
}

static int lcm_unprepare(struct drm_panel *panel)
{
	struct lcm *ctx = panel_to_lcm(panel);

	if (!ctx->prepared)
		return 0;

	lcm_dcs_write_seq_static(ctx, 0x28);
	msleep(70);
	lcm_dcs_write_seq_static(ctx, 0x10);
	msleep(100);
	
	// lcd reset L
	ctx->reset_gpio = devm_gpiod_get(ctx->dev, "reset", GPIOD_OUT_HIGH);
	gpiod_set_value(ctx->reset_gpio, 0);
	msleep(10);
	devm_gpiod_put(ctx->dev, ctx->reset_gpio);
	
	//lcd vci L
	ctx->bias_neg = devm_gpiod_get_index(ctx->dev, "bias", 1, GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->bias_neg)) {
		dev_err(ctx->dev, "%s: cannot get bias_neg %ld\n",
			__func__, PTR_ERR(ctx->bias_neg));
		return PTR_ERR(ctx->bias_neg);
	}
	gpiod_set_value(ctx->bias_neg, 0);
	devm_gpiod_put(ctx->dev, ctx->bias_neg);
	msleep(10);
	
	// lcd dvdd L
	ctx->bias_pos = devm_gpiod_get_index(ctx->dev, "bias", 0, GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->bias_pos)) {
		dev_err(ctx->dev, "%s: cannot get bias_pos %ld\n",
			__func__, PTR_ERR(ctx->bias_pos));
		return PTR_ERR(ctx->bias_pos);
	}
	gpiod_set_value(ctx->bias_pos, 0);
	devm_gpiod_put(ctx->dev, ctx->bias_pos);
	msleep(5);	

	// lcd ldo 1.8v
	ctx->vldo18_gpio = devm_gpiod_get(ctx->dev, "vldo18", GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->vldo18_gpio)) {
		dev_err(ctx->dev, "%s: cannot get vldo18 %ld\n",
			__func__, PTR_ERR(ctx->vldo18_gpio));
		return PTR_ERR(ctx->vldo18_gpio);
	}
	gpiod_set_value(ctx->vldo18_gpio, 0);
	devm_gpiod_put(ctx->dev, ctx->vldo18_gpio);
	msleep(5);
	
	ctx->error = 0;
	ctx->prepared = false;

	return 0;
}

static int lcm_prepare(struct drm_panel *panel)
{
	struct lcm *ctx = panel_to_lcm(panel);
	int ret;

	pr_info("%s+\n", __func__);
	if (ctx->prepared)
		return 0;

	// lcd ldo 1.8v
	ctx->vldo18_gpio = devm_gpiod_get(ctx->dev, "vldo18", GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->vldo18_gpio)) {
		dev_err(ctx->dev, "%s: cannot get vldo18 %ld\n",
			__func__, PTR_ERR(ctx->vldo18_gpio));
		return PTR_ERR(ctx->vldo18_gpio);
	}
	gpiod_set_value(ctx->vldo18_gpio, 1);
	devm_gpiod_put(ctx->dev, ctx->vldo18_gpio);
	msleep(5);
	
	// lcd dvdd H
	ctx->bias_pos = devm_gpiod_get_index(ctx->dev, "bias", 0, GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->bias_pos)) {
		dev_err(ctx->dev, "%s: cannot get bias_pos %ld\n",
			__func__, PTR_ERR(ctx->bias_pos));
		return PTR_ERR(ctx->bias_pos);
	}
	gpiod_set_value(ctx->bias_pos, 1);
	devm_gpiod_put(ctx->dev, ctx->bias_pos);
	msleep(5);
	
	//lcd vci H
	ctx->bias_neg = devm_gpiod_get_index(ctx->dev, "bias", 1, GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->bias_neg)) {
		dev_err(ctx->dev, "%s: cannot get bias_neg %ld\n",
			__func__, PTR_ERR(ctx->bias_neg));
		return PTR_ERR(ctx->bias_neg);
	}
	gpiod_set_value(ctx->bias_neg, 1);
	devm_gpiod_put(ctx->dev, ctx->bias_neg);
	msleep(10);
	
	// lcd reset H -> L -> L
	ctx->reset_gpio = devm_gpiod_get(ctx->dev, "reset", GPIOD_OUT_HIGH);
	gpiod_set_value(ctx->reset_gpio, 1);
	msleep(10);
	gpiod_set_value(ctx->reset_gpio, 0);
	msleep(10);
	gpiod_set_value(ctx->reset_gpio, 1);
	msleep(50);
	devm_gpiod_put(ctx->dev, ctx->reset_gpio);
	// end
	lcm_panel_init(ctx);

	ret = ctx->error;
	if (ret < 0)
		lcm_unprepare(panel);

	ctx->prepared = true;
#ifdef PANEL_SUPPORT_READBACK
	lcm_panel_get_data(ctx);
#endif

	pr_info("%s-\n", __func__);
	return ret;
}

static int lcm_enable(struct drm_panel *panel)
{
	struct lcm *ctx = panel_to_lcm(panel);

	if (ctx->enabled)
		return 0;

	if (ctx->backlight) {
		ctx->backlight->props.power = FB_BLANK_UNBLANK;
		backlight_update_status(ctx->backlight);
	}

	ctx->enabled = true;

	return 0;
}

#define HFP (16)
#define HSA (10)
#define HBP (12)
#define HACT (1080)
#define VFP (12)
#define VSA (10)
#define VBP (12)
#define VACT (2400)

static const struct drm_display_mode switch_mode_120hz = {
	.clock		= ((HACT+HFP+HSA+HBP)*(VACT+VFP+VSA+VBP)*(120)/1000),
	.hdisplay	= HACT,
	.hsync_start	= HACT + HFP,
	.hsync_end	= HACT + HFP + HSA,
	.htotal		= HACT + HFP + HSA + HBP,
	.vdisplay	= VACT,
	.vsync_start	= VACT + VFP,
	.vsync_end	= VACT + VFP + VSA,
	.vtotal		= VACT + VFP + VSA + VBP,
};

static const struct drm_display_mode switch_mode_60hz = {
	.clock		= ((HACT+HFP+HSA+HBP)*(VACT+VFP+VSA+VBP)*(60)/1000),
	.hdisplay	= HACT,
	.hsync_start	= HACT + HFP,
	.hsync_end	= HACT + HFP + HSA,
	.htotal		= HACT + HFP + HSA + HBP,
	.vdisplay	= VACT,
	.vsync_start	= VACT + VFP,
	.vsync_end	= VACT + VFP + VSA,
	.vtotal		= VACT + VFP + VSA + VBP,
};

#if defined(CONFIG_MTK_PANEL_EXT)
static struct mtk_panel_params ext_params_120hz = {
	.data_rate = 550*2,
	.pll_clk = 550,
	.cust_esd_check = 0,
	.esd_check_enable = 0,
	.lcm_esd_check_table[0] = {
		.cmd = 0x0a,
		.count = 1,
		.para_list[0] = 0x9c,
	},
	.physical_width_um = 69523,
	.physical_height_um = 154496,

	.dsc_params = {
		.enable = 0,
		.ver = 17,
		.slice_mode = 0,
		.rgb_swap = 0,
		.dsc_cfg = 2088,
		.rct_on = 1,
		.bit_per_channel = 10,
		.dsc_line_buf_depth = 11,
		.bp_enable = 1,
		.bit_per_pixel = 160,
		.pic_height = 2400,
		.pic_width = 1080,
		.slice_height = 40,
		.slice_width = 1080,
		.chunk_size = 1350,
		.xmit_delay = 410,
		.dec_delay = 688,
		.scale_value = 25,
		.increment_interval = 1230,
		.decrement_interval = 21,
		.line_bpg_offset = 12,
		.nfl_bpg_offset = 631,
		.slice_bpg_offset = 399,
		.initial_offset = 5632,
		.final_offset = 4332,
		.flatness_minqp = 7,
		.flatness_maxqp = 16,
		.rc_model_size = 8192,
		.rc_edge_factor = 6,
		.rc_quant_incr_limit0 = 15,
		.rc_quant_incr_limit1 = 15,
		.rc_tgt_offset_hi = 3,
		.rc_tgt_offset_lo = 3,
	},
};

static struct mtk_panel_params ext_params_60hz = {
	.data_rate = 550*2,
	.pll_clk = 550,
	.cust_esd_check = 0,
	.esd_check_enable = 0,
	.lcm_esd_check_table[0] = {
		.cmd = 0x0a,
		.count = 1,
		.para_list[0] = 0x9c,
	},
	.physical_width_um = 69523,
	.physical_height_um = 154496,

	.dsc_params = {
		.enable = 0,
		.ver = 17,
		.slice_mode = 0,
		.rgb_swap = 0,
		.dsc_cfg = 2088,
		.rct_on = 1,
		.bit_per_channel = 10,
		.dsc_line_buf_depth = 11,
		.bp_enable = 1,
		.bit_per_pixel = 160,
		.pic_height = 2400,
		.pic_width = 1080,
		.slice_height = 40,
		.slice_width = 1080,
		.chunk_size = 1350,
		.xmit_delay = 410,
		.dec_delay = 688,
		.scale_value = 25,
		.increment_interval = 1230,
		.decrement_interval = 21,
		.line_bpg_offset = 12,
		.nfl_bpg_offset = 631,
		.slice_bpg_offset = 399,
		.initial_offset = 5632,
		.final_offset = 4332,
		.flatness_minqp = 7,
		.flatness_maxqp = 16,
		.rc_model_size = 8192,
		.rc_edge_factor = 6,
		.rc_quant_incr_limit0 = 15,
		.rc_quant_incr_limit1 = 15,
		.rc_tgt_offset_hi = 3,
		.rc_tgt_offset_lo = 3,
	},
};

static int panel_ata_check(struct drm_panel *panel)
{
	/* Customer test by own ATA tool */
	return 1;
}

static int lcm_setbacklight_cmdq(void *dsi, dcs_write_gce cb, void *handle,
				 unsigned int level)
{
	unsigned char bl_tb[] = {0x51,0x00,0x00};
	unsigned char hbm_tb[] = {0x51,0x0F,0xFF};

	if (level > 4095) {
		if (level == 4096) {
			if (!cb)
				return -1;
			pr_err("%s panel into HBM", __func__);
			cb(dsi, handle, hbm_tb, ARRAY_SIZE(hbm_tb));
		} else if (level == 4097) {
			if (rawlevel <= 0x1FFF) {
				bl_tb[1] = (unsigned char)((rawlevel>>8)&0x1f);
				bl_tb[2] = (unsigned char)(rawlevel&0xff);
			} else {
				pr_err("%s err, rawlevel=%d\n", __func__, rawlevel);
			}
			if (!cb)
				return -1;
			pr_err("%s panel out HBM, rawlevel=%d, bl_tb[1]=0x%x, bl_tb[2]=0x%x\n",
				__func__, rawlevel, bl_tb[1], bl_tb[2]);
			cb(dsi, handle, bl_tb, ARRAY_SIZE(bl_tb));
		}
	} else {
		if (level) {
			rawlevel = level*1023/255;
		} else {
			rawlevel = 0;
		}
		if (rawlevel <= 1023) {
			bl_tb[1] = (unsigned char)((rawlevel>>8)&0x1f);
			bl_tb[2] = (unsigned char)(rawlevel&0xff);
			if (!cb)
				return -1;
			cb(dsi, handle, bl_tb, ARRAY_SIZE(bl_tb));
			pr_err("%s level=%d, rawlevel=%d, bl_tb[1]=0x%x, bl_tb[2]=0x%x\n",
				__func__, level, rawlevel, bl_tb[1], bl_tb[2]);
		} else {
			pr_err("%s err, rawlevel=%d\n", __func__, rawlevel);
		}
	}
	
	return 0;
}

static int panel_ext_reset(struct drm_panel *panel, int on)
{
	struct lcm *ctx = panel_to_lcm(panel);

	ctx->reset_gpio =
		devm_gpiod_get(ctx->dev, "reset", GPIOD_OUT_HIGH);
	gpiod_set_value(ctx->reset_gpio, on);
	devm_gpiod_put(ctx->dev, ctx->reset_gpio);

	return 0;
}

struct drm_display_mode *get_mode_by_id(struct drm_connector *connector,
	unsigned int mode)
{
	struct drm_display_mode *m;
	unsigned int i = 0;

	list_for_each_entry(m, &connector->modes, head) {
		if (i == mode)
			return m;
		i++;
	}
	return NULL;
}

static int mtk_panel_ext_param_set(struct drm_panel *panel,
			struct drm_connector *connector, unsigned int mode)
{
	struct mtk_panel_ext *ext = find_panel_ext(panel);
	int ret = 0;
	struct drm_display_mode *m = get_mode_by_id(connector, mode);
	if (!m) {
		pr_err("%s:%d invalid display_mode\n", __func__, __LINE__);
		return ret;
	}
	if (drm_mode_vrefresh(m) == 120)
		ext->params = &ext_params_120hz;
	else if (drm_mode_vrefresh(m) == 60)
		ext->params = &ext_params_60hz;
	else
		ret = 1;

	return ret;
}

static void mode_switch_to_120(struct drm_panel *panel,
	enum MTK_PANEL_MODE_SWITCH_STAGE stage)
{
	if (stage == BEFORE_DSI_POWERDOWN) {
		// struct lcm *ctx = panel_to_lcm(panel);

		// lcm_dcs_write_seq_static(ctx, 0xFE, 0x00);
		// lcm_dcs_write_seq_static(ctx, 0x02, 0x05);
	}
}

static void mode_switch_to_60(struct drm_panel *panel,
	enum MTK_PANEL_MODE_SWITCH_STAGE stage)
{
	if (stage == BEFORE_DSI_POWERDOWN) {
		// struct lcm *ctx = panel_to_lcm(panel);

		// lcm_dcs_write_seq_static(ctx, 0xFE, 0x00);
		// lcm_dcs_write_seq_static(ctx, 0x02, 0x00);
	}
}

static int mode_switch(struct drm_panel *panel,
		struct drm_connector *connector, unsigned int cur_mode,
		unsigned int dst_mode, enum MTK_PANEL_MODE_SWITCH_STAGE stage)
{
	int ret = 0;
	struct drm_display_mode *m = get_mode_by_id(connector, dst_mode);

	if (cur_mode == dst_mode)
		return ret;
	if (drm_mode_vrefresh(m) == 60) { /*switch to 60 */
		mode_switch_to_60(panel, stage);
	} else if (drm_mode_vrefresh(m) == 120) { /*switch to 120 */
		mode_switch_to_120(panel, stage);
	} else
		ret = 1;

	return ret;
}

static int panel_doze_enable(struct drm_panel *panel,
	void *dsi_drv, dcs_write_gce cb, void *handle)
{
	pr_err("%s", __func__);

	return 0;
}

static int panel_doze_disable(struct drm_panel *panel,
	void *dsi_drv, dcs_write_gce cb, void *handle)
{
	pr_err("%s", __func__);

	return 0;
}

static int panel_set_aod_light_mode(void *dsi_drv, dcs_write_gce cb,
	void *handle, unsigned int mode)
{
	pr_err("%s, mode%d", __func__, mode);

	return 0;
}

static struct mtk_panel_funcs ext_funcs = {
	.reset = panel_ext_reset,
	.set_backlight_cmdq = lcm_setbacklight_cmdq,
	.ata_check = panel_ata_check,
	.ext_param_set = mtk_panel_ext_param_set,
	.mode_switch = mode_switch,
	.doze_enable = panel_doze_enable,
	.doze_disable = panel_doze_disable,
	.set_aod_light_mode = panel_set_aod_light_mode,
};
#endif

static int lcm_get_modes(struct drm_panel *panel,
					struct drm_connector *connector)
{
	struct drm_display_mode *mode;
	struct drm_display_mode *mode_1;

	mode = drm_mode_duplicate(connector->dev, &switch_mode_120hz);
	if (!mode) {
		dev_info(connector->dev->dev, "failed to add mode %ux%ux@%u\n",
			 switch_mode_120hz.hdisplay, switch_mode_120hz.vdisplay,
			 drm_mode_vrefresh(&switch_mode_120hz));
		return -ENOMEM;
	}

	drm_mode_set_name(mode);
	mode->type = DRM_MODE_TYPE_DRIVER | DRM_MODE_TYPE_PREFERRED;
	drm_mode_probed_add(connector, mode);

	mode_1 = drm_mode_duplicate(connector->dev, &switch_mode_60hz);
	if (!mode_1) {
		dev_info(connector->dev->dev, "failed to add mode %ux%ux@%u\n",
			switch_mode_60hz.hdisplay, switch_mode_60hz.vdisplay,
			drm_mode_vrefresh(&switch_mode_60hz));
		return -ENOMEM;
	}

	drm_mode_set_name(mode_1);
	mode_1->type = DRM_MODE_TYPE_DRIVER;
	drm_mode_probed_add(connector, mode_1);

	connector->display_info.width_mm = 64;
	connector->display_info.height_mm = 129;

	return 1;
}

static const struct drm_panel_funcs lcm_drm_funcs = {
	.disable = lcm_disable,
	.unprepare = lcm_unprepare,
	.prepare = lcm_prepare,
	.enable = lcm_enable,
	.get_modes = lcm_get_modes,
};

static int lcm_probe(struct mipi_dsi_device *dsi)
{
	struct device *dev = &dsi->dev;
	struct device_node *dsi_node, *remote_node = NULL, *endpoint = NULL;
	struct lcm *ctx;
	struct device_node *backlight;
	int ret;

	pr_info("%s+\n", __func__);

	dsi_node = of_get_parent(dev->of_node);
	if (dsi_node) {
		endpoint = of_graph_get_next_endpoint(dsi_node, NULL);
		if (endpoint) {
			remote_node = of_graph_get_remote_port_parent(endpoint);
			if (!remote_node) {
				pr_info("No panel connected,skip probe lcm\n");
				return -ENODEV;
			}
			pr_info("device node name:%s\n", remote_node->name);
		}
	}
	if (remote_node != dev->of_node) {
		pr_info("%s+ skip probe due to not current lcm\n", __func__);
		return -ENODEV;
	}

	ctx = devm_kzalloc(dev, sizeof(struct lcm), GFP_KERNEL);
	if (!ctx)
		return -ENOMEM;

	mipi_dsi_set_drvdata(dsi, ctx);

	ctx->dev = dev;
	dsi->lanes = 4;
	dsi->format = MIPI_DSI_FMT_RGB888;
	dsi->mode_flags = MIPI_DSI_MODE_LPM | MIPI_DSI_MODE_EOT_PACKET
			 | MIPI_DSI_CLOCK_NON_CONTINUOUS;

	backlight = of_parse_phandle(dev->of_node, "backlight", 0);
	if (backlight) {
		ctx->backlight = of_find_backlight_by_node(backlight);
		of_node_put(backlight);

		if (!ctx->backlight)
			return -EPROBE_DEFER;
	}

	ctx->reset_gpio = devm_gpiod_get(dev, "reset", GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->reset_gpio)) {
		dev_info(dev, "cannot get reset-gpios %ld\n",
			 PTR_ERR(ctx->reset_gpio));
		return PTR_ERR(ctx->reset_gpio);
	}
	devm_gpiod_put(dev, ctx->reset_gpio);

	ctx->vldo18_gpio = devm_gpiod_get(dev, "vldo18", GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->vldo18_gpio)) {
		dev_info(dev, "cannot get vldo18-gpios %ld\n",
			 PTR_ERR(ctx->vldo18_gpio));
		return PTR_ERR(ctx->vldo18_gpio);
	}
	devm_gpiod_put(dev, ctx->vldo18_gpio);
	
	ctx->bias_pos = devm_gpiod_get_index(dev, "bias", 0, GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->bias_pos)) {
		dev_info(dev, "cannot get bias-gpios 0 %ld\n",
			 PTR_ERR(ctx->bias_pos));
		return PTR_ERR(ctx->bias_pos);
	}
	devm_gpiod_put(dev, ctx->bias_pos);
	
	ctx->bias_neg = devm_gpiod_get_index(dev, "bias", 1, GPIOD_OUT_HIGH);
	if (IS_ERR(ctx->bias_neg)) {
		dev_info(dev, "cannot get bias-gpios 1 %ld\n",
			 PTR_ERR(ctx->bias_neg));
		return PTR_ERR(ctx->bias_neg);
	}
	devm_gpiod_put(dev, ctx->bias_neg);
	
	ctx->prepared = true;
	ctx->enabled = true;
	drm_panel_init(&ctx->panel, dev, &lcm_drm_funcs, DRM_MODE_CONNECTOR_DSI);

	drm_panel_add(&ctx->panel);

	ret = mipi_dsi_attach(dsi);
	if (ret < 0)
		drm_panel_remove(&ctx->panel);

#if defined(CONFIG_MTK_PANEL_EXT)
	mtk_panel_tch_handle_reg(&ctx->panel);
	ret = mtk_panel_ext_create(dev, &ext_params_60hz, &ext_funcs, &ctx->panel);
	if (ret < 0)
		return ret;

#endif

	g_ctx = ctx;

	pr_info("%s- lcm,sh8804b,cmd\n", __func__);

#if IS_ENABLED(CONFIG_PRIZE_HARDWARE_INFO)
    strcpy(current_lcm_info.chip,"sh8804b,cmd,daxian");
    strcpy(current_lcm_info.vendor,"Shenghe Microelectronics");
    sprintf(current_lcm_info.id,"0x%02x",0x00);
    strcpy(current_lcm_info.more,"1080*2400");
#endif
	return ret;
}

static int lcm_remove(struct mipi_dsi_device *dsi)
{
	struct lcm *ctx = mipi_dsi_get_drvdata(dsi);
#if defined(CONFIG_MTK_PANEL_EXT)
	struct mtk_panel_ctx *ext_ctx = find_panel_ctx(&ctx->panel);
#endif

	mipi_dsi_detach(dsi);
	drm_panel_remove(&ctx->panel);
#if defined(CONFIG_MTK_PANEL_EXT)
	mtk_panel_detach(ext_ctx);
	mtk_panel_remove(ext_ctx);
#endif

	return 0;
}

static const struct of_device_id lcm_of_match[] = {
	{
	    .compatible = "daxian,sh8804b,cmd",
	},
	{}
};

MODULE_DEVICE_TABLE(of, lcm_of_match);

static struct mipi_dsi_driver lcm_driver = {
	.probe = lcm_probe,
	.remove = lcm_remove,
	.driver = {
		.name = "panel-daxian-sh8804b-dphy-cmd-120hz",
		.owner = THIS_MODULE,
		.of_match_table = lcm_of_match,
	},
};

module_mipi_dsi_driver(lcm_driver);

MODULE_AUTHOR("MEDIATEK");
MODULE_DESCRIPTION("sh8804b AMOLED CMD LCD Panel Driver");
MODULE_LICENSE("GPL v2");
